con

  _clkmode = xtal1+pll16x
  _clkfreq = 114_285_714

  _SD_DO = 20
  _SD_CLK = 21
  _SD_DI = 22
  _SD_CS = 23
  _SD_WP = -1 ' -1 ifnot installed.
  _SD_CD = -1 ' -1 ifnot installed.



obj
  vga           : "vnfg098"
  fat           : "kyefat_lfn"
  i2c           : "i2cdrv"
  sid           : "SIDcog44-0.95"     


var
byte name[10]
long buf[896]
byte buffer2[25]
long buffer3[1024]
long playstack[128]
long playcog
long flen
long flag

  
pub boot   |i  ,j ,k,l  ,  c,w,s  ,wait ,q  ,ss   ,qq    ,xx,yy,xxd,yyd,pos


vga.start   

 
i2c.start(18)        'sound chip init
i2c.write(18,$34)
i2c.write(18,$12)
i2c.write(18,$0)
i2c.stop(18)


i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$1)
i2c.write(18,$1f)
i2c.stop(18)


i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$8)
i2c.write(18,$12)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$0a)
i2c.write(18,$0)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$0c)
i2c.write(18,$62)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$0e)
i2c.write(18,$1b)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$10)
i2c.write(18,$22)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$6)
i2c.write(18,$78)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$4)
i2c.write(18,$78)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$12)
i2c.write(18,$1)
i2c.stop(18)


  
repeat i from $83000 to $83023     ' clear display and audio registers
  vga.poke(i,0)
repeat i from $84000 to $843ff     ' clear audio buffer
  vga.poke(i,0) 
repeat i from $70000 to $71000     ' clear DL area
  vga.poke(i,0) 

vga.poke($83000+36,0)              ' switch off leds and hex
vga.poke($83000+37,$FFFFFFFF)
vga.poke($83000+38,$FFFFFFFF)
vga.poke($83003,255)
vga.poke($83006,0) '$80070000)          ' DL @ $70000 on
vga.poke($70020,%11_0000_0000_0000_00_0000_0000_0000_0000)
vga.poke($70280,%11_0000_0010_0000_00_0000_0000_0000_0000)

 
vga.poke ($83009,$80008000+2000)    'move sprites away 
vga.poke ($8300a,$80008000+2000)
vga.poke ($8300b,$80008000+2000)
vga.poke ($8300c,$80008000+2000)
vga.poke ($8300d,$80008000+2000)     
vga.poke ($8300e,$80008000+2000)


vga.graphics(0)
vga.setcolor(1,255,0,0)



vga.graphics(10)
vga.cls
vga.outtextxy(0,8,string("SIDCog-44k1 demo"),232) 
repeat i from 1 to 7
  vga.line(0,i-1,200,i-1,i*16+8)
repeat i from 8 to 15
  vga.line(0,i+16,200,i+16,i*16+8)       
repeat i from 0 to 31
  repeat j from 0 to 7
    vga.poke($82000+j+8*i,vga.peek(j+112*i))
repeat i from 0 to 31
  repeat j from 0 to 7
    vga.poke($82100+j+8*i,vga.peek(8+j+112*i))
    
repeat i from 0 to 31
  repeat j from 0 to 7
    vga.poke($82200+j+8*i,vga.peek(16+j+112*i))
repeat i from 0 to 31
  repeat j from 0 to 7
    vga.poke($82300+j+8*i,vga.peek(24+j+112*i))
    
vga.poke($83009,$027803c0)    
vga.poke($8300a,$027803e0)    
vga.poke($8300b,$02780400)    
vga.poke($8300c,$02780420)

vga.graphics(8)
vga.cls
vga.poke($83002,12)
vga.setataripallette(1)
vga.set222pallette(0) 
vga.poke($83006,0)
vga.poke($83005,0)
vga.poke($83007,0)
vga.poke($8302B,0)
vga.poke ($83000+37,$FFFFFFFF)
fat.FATEngineStart(_SD_DO, _SD_CLK, _SD_DI, _SD_CS, _SD_WP, _SD_CD, -1, -1, -1)   
i:=fat.mountpartition(0)    
fat.openfile(string("c64.ham"),"R")
fat.readdata(@buf,256)
repeat i from 0 to 63
  vga.setcolor(i,buf[i]&255,(buf[i]>>8)&255,(buf[i]>>16)&255)
repeat i from 0 to 559
  fat.readdata(@buf,896)
  vga.blit2(@buf,224*i,224)


i:=66
j:=159
bytefill(@buffer2,0,25)
sid.start
sid.updateRegisters(@buffer2)   

vga.poke ($83000+37,$FFFFFF00)

vga.poke ($83000+37,$FFFF0000) 
xxd:=1
yyd:=1
xx:=100
yy:=100

vga.poke ($83000+37,$FFFFFFFF)

vga.poke ($83010,0)
vga.poke ($83011,0)
vga.poke ($83012,0)
vga.poke ($83013,0)
vga.poke ($8302a,0)

vga.poke($8302B,255) 


'vga.poke($83000+38,%11111111_11111111_00011001_00011001) 
'vga.poke($83000+37,%11111001_01000000_01000000_11111111)
{{
repeat i from 1 to 8
  name[0]:="0"
  name[1]:=48+(i/10)
  name[2]:=48+(i//10)
  name[3]:="."
  name[4]:="w"
  name[5]:="a"
  name[6]:="v"
  name[7]:=0


  fat.openfile(@name,"R")
  repeat
    c:=\fat.readdata(@buffer3,2048)
   
    xx:=xx+xxd
    yy:=yy+yyd
    if (xx>1900)
       xxd:=-1
    if (xx<170)
      xxd:=1
    if (yy<65)
      yyd:=1
    if (yy>1150)
      yyd:=-1
  
    vga.poke($83009,$40004000+xx+(yy<<16))    
    vga.poke($8300a,$40004000+64+xx+(yy<<16))    
    vga.poke($8300b,$40004000+128+xx+(yy<<16))  
    vga.poke($8300c,$40004000+192+xx+(yy<<16))






  
    repeat
    until ina[4]==1
    vga.blit2(@buffer3,$84000,512)
    c:=\fat.readdata(@buffer3,2048)
  
    xx:=xx+xxd
    yy:=yy+yyd
    if (xx>1900)
       xxd:=-1
    if (xx<170)
      xxd:=1
    if (yy<65)
      yyd:=1
    if (yy>1150)
      yyd:=-1
  
    vga.poke($83009,$40004000+xx+(yy<<16))    
    vga.poke($8300a,$40004000+64+xx+(yy<<16))    
    vga.poke($8300b,$40004000+128+xx+(yy<<16))  
    vga.poke($8300c,$40004000+192+xx+(yy<<16))
    repeat
    until ina[4]==0
    vga.blit2(@buffer3,$84200,512)
  until c<>2048  
  fat.closefile
}}   
repeat i from $84000 to $843ff
  vga.poke(i,0)

vga.poke($8302B,255) 
s:=sid.getsidsample
vga.audiocmd (s)
vga.setirq(64)


repeat i from 1 to 24
  name[0]:="0"
  name[1]:=48+(i/10)
  name[2]:=48+(i//10)
  name[3]:="."
  name[4]:="d"
  name[5]:="m"
  name[6]:="p"
  name[7]:=0 
  fat.openfile(@name,"R") 
  wait:=cnt+clkfreq/50
  repeat
    ss:=vga.peek($83000+39)&7
    if ss==0
      qq:=50
      vga.poke($83000+37,%11111111_11111111_10010010_11000000)
    if ss==1
      qq:=100
      vga.poke($83000+37,%11111111_11111001_11000000_11000000)     
    if ss==2
      qq:=150
      vga.poke($83000+37,%11111111_11111001_10010010_11000000)     
    if ss==4
      qq:=200
      vga.poke($83000+37,%11111111_10100100_11000000_11000000)   
      
    w:=clkfreq/qq

    xx:=xx+xxd
    yy:=yy+yyd
    if (xx>1900)
       xxd:=-1
    if (xx<170)
      xxd:=1
    if (yy<65)
      yyd:=1
    if (yy>1150)
      yyd:=-1
  
    vga.poke($83009,$50004000+xx+(yy<<16))    
    vga.poke($8300a,$50004000+64+xx+(yy<<16))    
    vga.poke($8300b,$50004000+128+xx+(yy<<16))  
    vga.poke($8300c,$50004000+192+xx+(yy<<16))
    
    c:=fat.readdata(@buffer2,25)    
'    if wait>cnt
    waitcnt(wait)  
    wait:=wait+w
    sid.updateRegisters(@buffer2)
  until (c<>25)
  fat.closefile
  bytefill(@buffer2,0,25)
  sid.updateRegisters(@buffer2)




  